package com.sun.net.ssl;

import java.security.UnrecoverableKeyException;
import java.security.KeyStoreException;
import java.security.KeyStore;
import java.security.NoSuchProviderException;
import java.security.NoSuchAlgorithmException;
import java.security.AccessController;
import java.security.Security;
import java.security.PrivilegedAction;
import java.security.Provider;

@Deprecated
public class KeyManagerFactory
{
    private Provider provider;
    private KeyManagerFactorySpi factorySpi;
    private String algorithm;
    
    public static final String getDefaultAlgorithm() {
        String s = (String)AccessController.doPrivileged(new PrivilegedAction<String>() {
            @Override
            public String run() {
                return Security.getProperty("sun.ssl.keymanager.type");
            }
        });
        if (s == null) {
            s = "SunX509";
            return s;
        }
        return s;
    }
    
    protected KeyManagerFactory(KeyManagerFactorySpi factorySpi, Provider provider, String algorithm) {
        this.factorySpi = factorySpi;
        this.provider = provider;
        this.algorithm = algorithm;
    }
    
    public final String getAlgorithm() {
        return this.algorithm;
    }
    
    public static final KeyManagerFactory getInstance(String str) throws NoSuchAlgorithmException {
        try {
            Object[] impl = SSLSecurity.getImpl(str, "KeyManagerFactory", (String)null);
            return new KeyManagerFactory((KeyManagerFactorySpi)impl[0], (Provider)impl[1], str);
        }
        catch (NoSuchProviderException ex) {
            throw new NoSuchAlgorithmException(str + " not found");
        }
    }
    
    public static final KeyManagerFactory getInstance(String s, String s2) throws NoSuchAlgorithmException, NoSuchProviderException {
        if (s2 == null || s2.length() == 0) {
            throw new IllegalArgumentException("missing provider");
        }
        Object[] impl = SSLSecurity.getImpl(s, "KeyManagerFactory", s2);
        return new KeyManagerFactory((KeyManagerFactorySpi)impl[0], (Provider)impl[1], s);
    }
    
    public static final KeyManagerFactory getInstance(String s, Provider provider) throws NoSuchAlgorithmException {
        if (provider == null) {
            throw new IllegalArgumentException("missing provider");
        }
        Object[] impl = SSLSecurity.getImpl(s, "KeyManagerFactory", provider);
        return new KeyManagerFactory((KeyManagerFactorySpi)impl[0], (Provider)impl[1], s);
    }
    
    public final Provider getProvider() {
        return this.provider;
    }
    
    public void init(KeyStore keyStore, char[] array) throws KeyStoreException, NoSuchAlgorithmException, UnrecoverableKeyException {
        this.factorySpi.engineInit(keyStore, array);
    }
    
    public KeyManager[] getKeyManagers() {
        return this.factorySpi.engineGetKeyManagers();
    }
}
